//=============================================================================
//
//  CLASS DecodingViewer
//
//=============================================================================


#ifndef DECODING_VIEWER_HH
#define DECODING_VIEWER_HH


//== INCLUDES =================================================================

#include "../01-ValenceViewer/MeshViewer.hh"

//== CLASS DEFINITION =========================================================

#include <list>
#include <fstream>
using namespace std;    

class DecodingViewer : public MeshViewer
{
public:
 
  /// default constructor
  DecodingViewer(const char* _title, int _width, int _height, const char* _inputfile, const char* _outputfile);

  // destructor
  ~DecodingViewer();

protected:
  /// draw the scene
  virtual void draw(const std::string& _draw_mode);

  // overloaded glut functions
  virtual void keyboard(int key, int x, int y);

private:
  void decode();

  void write_off();

  bool ReadPoint(ifstream &iInputStream, Mesh::Point &oPoint, int &oValence);

  bool update_scene();

  void RemoveFullVertex(std::list<Mesh::VertexHandle> &ioCutBorder, std::list<Mesh::VertexHandle>::iterator &iVertexIt, 
                        std::list<Mesh::VertexHandle>::iterator &oVertexItNext);

private:
  const char *_InputFileName;
  const char *_OutputFileName;  

  OpenMesh::VPropHandleT<int>  _nFreeEdges;
};


//=============================================================================
#endif // DECODING_VIEWER_HH defined
//=============================================================================

